diff --git a/game/core/src/main/resources/lang/en_US/worldsettings.lang b/game/core/src/main/resources/lang/en_US/worldsettings.lang
new file mode 100644
index 000000000..393824780
--- /dev/null
+++ b/game/core/src/main/resources/lang/en_US/worldsettings.lang
@@ -0,0 +1,12 @@
+world_settings.values.on=ON
+world_settings.values.off=OFF
+
+world_settings.world_height.bottom.name=World Height at Bottom
+world_settings.world_height.ocean.name=Ocean Height
+world_settings.world_height.top.name=World Height at Top
+world_settings.single_season.enabled.name=Single Season
+world_settings.single_season.value.name=
+world_settings.starting_biome.enabled.name=Starting Biome
+world_settings.starting_biome.value.name=
+world_settings.single_biome.enabled.name=Single Biome
+world_settings.single_biome.value.name=
\ No newline at end of file
diff --git a/game/server/src/main/java/net/minecraft/server/MinecraftServer.java b/game/server/src/main/java/net/minecraft/server/MinecraftServer.java
index a49350ddf..df7242fef 100644
--- a/game/server/src/main/java/net/minecraft/server/MinecraftServer.java
+++ b/game/server/src/main/java/net/minecraft/server/MinecraftServer.java
@@ -59,6 +59,8 @@ import net.minecraft.core.player.gamemode.Gamemodes;
 import net.minecraft.core.util.pool.ObjectPool;
 import net.minecraft.core.util.helper.UUIDHelper;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.settings.WorldConfiguration;
+import net.minecraft.core.world.type.WorldTypeGroups;
 import net.minecraft.server.entity.player.PlayerServer;
 import net.minecraft.server.net.MulticastPublisher;
 import net.minecraft.server.net.command.ConsoleCommandSource;
@@ -536,7 +538,16 @@ public class MinecraftServer
             WorldServer worldServer;
             if (dimension.id == 0)
             {
-                worldServer = new WorldServer(this, levelStorage, worldDirName, seed, dimension);
+                final @NotNull WorldConfiguration worldConfiguration = new WorldConfiguration();
+                for (final @NotNull WorldTypeGroups.Group group : WorldTypeGroups.GROUPS) {
+                    if (group.get(dimension).equals(this.defaultWorldType)) {
+                        worldConfiguration.setWorldTypeGroup(group);
+                        break;
+                    }
+                }
+                worldConfiguration.setWorldName(worldDirName);
+                worldConfiguration.setNumericSeed(seed);
+                worldServer = new WorldServer(this, levelStorage, worldConfiguration, dimension);
             }
             else
             {
diff --git a/game/server/src/main/java/net/minecraft/server/world/WorldServer.java b/game/server/src/main/java/net/minecraft/server/world/WorldServer.java
index a25fbbe06..68bf64b70 100644
--- a/game/server/src/main/java/net/minecraft/server/world/WorldServer.java
+++ b/game/server/src/main/java/net/minecraft/server/world/WorldServer.java
@@ -27,6 +27,7 @@ import net.minecraft.core.world.chunk.provider.ChunkProvider;
 import net.minecraft.core.world.pos.TilePosc;
 import net.minecraft.core.world.save.LevelStorage;
 import net.minecraft.core.world.saveddata.SavedDataStorage;
+import net.minecraft.core.world.settings.WorldConfiguration;
 import net.minecraft.server.MinecraftServer;
 import net.minecraft.server.world.chunk.provider.ChunkProviderServer;
 import org.jetbrains.annotations.NotNull;
@@ -45,11 +46,10 @@ public class WorldServer extends World {
     public WorldServer(
         final @NotNull MinecraftServer server,
         final @NotNull LevelStorage levelStorage,
-        final @NotNull String name,
-        final long seed,
+        final @Nullable WorldConfiguration worldConfiguration,
         final @NotNull Dimension dimension
     ) {
-        super(levelStorage, name, seed, dimension, null);
+        super(levelStorage, worldConfiguration, dimension);
 
         entityIntHashMap = new Int2ObjectOpenHashMap<>();
         mcServer = server;
diff --git a/util/nbt/src/main/java/com/mojang/nbt/tags/CompoundTag.java b/util/nbt/src/main/java/com/mojang/nbt/tags/CompoundTag.java
index 6eaae0cf6..bac09bd55 100644
--- a/util/nbt/src/main/java/com/mojang/nbt/tags/CompoundTag.java
+++ b/util/nbt/src/main/java/com/mojang/nbt/tags/CompoundTag.java
@@ -82,7 +82,7 @@ public class CompoundTag extends Tag<@NotNull Map<String, Tag<?>>>
         return getValue().containsKey(key);
     }
 
-    public Collection<Tag<?>> getValues()
+    public @NotNull Collection<@NotNull Tag<?>> getValues()
     {
         return getValue().values();
     }
diff --git a/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/BTAChunkProvider.java b/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/BTAChunkProvider.java
index 78fcbab91..f31b26326 100644
--- a/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/BTAChunkProvider.java
+++ b/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/BTAChunkProvider.java
@@ -41,12 +41,15 @@ public class BTAChunkProvider implements ChunkProvider {
 
 
     public BTAChunkProvider(long seed) {
-        this.biomeProvider = new BiomeProviderOverworld(seed, WorldTypes.OVERWORLD_EXTENDED);
+//        this.biomeProvider = new BiomeProviderOverworld(seed, WorldTypes.OVERWORLD_EXTENDED);
+        // TODO: Fix
+        throw new IllegalArgumentException("This is currently broken!");
     }
 
     public BTAChunkProvider(File worldFolder, LevelData data) {
-        this.biomeProvider = new BiomeProviderOverworld(data.getRandomSeed(), WorldTypes.OVERWORLD_EXTENDED);
+//        this.biomeProvider = new BiomeProviderOverworld(data.getRandomSeed(), WorldTypes.OVERWORLD_EXTENDED);
         this.chunkLoader = new ChunkLoader(worldFolder, Dimension.OVERWORLD);
+        throw new IllegalArgumentException("This is currently broken!");
     }
     @Override
     public ViewerChunk getChunk(ChunkPos location) {
diff --git a/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/BTAWorld.java b/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/BTAWorld.java
index c12cff37d..97e631027 100644
--- a/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/BTAWorld.java
+++ b/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/BTAWorld.java
@@ -1,5 +1,6 @@
 package org.useless.seedviewer.bta;
 
+import net.minecraft.core.world.World;
 import net.minecraft.core.world.save.LevelData;
 import org.jetbrains.annotations.NotNull;
 import org.useless.seedviewer.bta.worldloader.LevelDataLoader;
diff --git a/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/DummyWorld.java b/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/DummyWorld.java
index 62c0f422b..0d485d500 100644
--- a/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/DummyWorld.java
+++ b/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/DummyWorld.java
@@ -6,6 +6,7 @@ import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.chunk.provider.ChunkProvider;
 import net.minecraft.core.world.save.LevelStorage;
 import net.minecraft.core.world.save.LevelStorageDummy;
+import net.minecraft.core.world.settings.WorldConfiguration;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.useless.seedviewer.bta.worldloader.ChunkLoader;
@@ -16,10 +17,8 @@ import java.util.Objects;
 public class DummyWorld extends World {
     public static @Nullable ChunkLoader CHUNK_LOADER = null;
 
-    public DummyWorld(
-        final @NotNull Dimension dimension
-    ) {
-        super(new LevelStorageDummy(), "Dummy World", 0, dimension, null);
+    public DummyWorld(final @NotNull Dimension dimension) {
+        super(new LevelStorageDummy(), new WorldConfiguration(), dimension);
     }
 
     @Override
diff --git a/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/worldloader/LevelDataLoader.java b/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/worldloader/LevelDataLoader.java
index 3a7d15cff..881ebd5cc 100644
--- a/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/worldloader/LevelDataLoader.java
+++ b/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/worldloader/LevelDataLoader.java
@@ -21,7 +21,7 @@ public class LevelDataLoader {
         Objects.requireNonNull(worldDir, "WorldDir must not be null!");
         CompoundTag tag = getLevelDataRaw(worldDir);
         if (tag == null) return null;
-        return LevelData.fromCompoundTag(tag);
+        return LevelData.deserialize(tag);
     }
 
     @Nullable
diff --git a/util/seed-viewer/src/main/java/org/useless/seedviewer/data/ViewerWorld.java b/util/seed-viewer/src/main/java/org/useless/seedviewer/data/ViewerWorld.java
index ff311b26f..01f1219d8 100644
--- a/util/seed-viewer/src/main/java/org/useless/seedviewer/data/ViewerWorld.java
+++ b/util/seed-viewer/src/main/java/org/useless/seedviewer/data/ViewerWorld.java
@@ -1,5 +1,7 @@
 package org.useless.seedviewer.data;
 
+import net.minecraft.core.world.World;
+import org.jetbrains.annotations.NotNull;
 import org.useless.seedviewer.gui.ChunkProvider;
 
 import java.io.File;
